/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package queue;

import java.util.Arrays;
import java.util.Comparator;

/**
 *
 * @author Y.Nakonech
 */
public class TableFunction {

    public class TableException extends Exception {
    }
    private Point[] points;
    private int index;

    public TableFunction(int size){
        points = new Point[size];
        index = 0;
    }

    double getY(double x) throws TableException {
        for(Point point: points){
            if (point.x==x) return point.y;
        }
        throw new TableException();
    }

    void put(double x, double y){
        points[index] = new Point(x, y);
        index++;
    }

    int getNearestIndex(double x){

        int index = 0;

        while(points[index].x <= x){
            index++;
          }
        return index;
    }

    double count(double x){
       int index = getNearestIndex(x);
       double value = 0;

       value = (x - points[index].x)/
               (points[index+1].x - points[index].x)*
               (points[index+1].y - points[index].y)+
               points[index].y;
      return value;
    }

    void sort(){
        Arrays.sort(points, new Comparator<Point>(){
            public int compare(Point o1, Point o2) {
                if (o2 == null) return -1 ;
                if (o1 == null) return 1;
                
                return (int)(o1.x - o2.x);
            }
        });
    }


@Override
    public String toString() {
        String result = "";

        for(int i = 0; i < index; i++){
            Point point = points[i];
            result = result + "x=" + point.x + "; y=" + point.y + "\n";
        }
        return result;
    }




}
